
/*See common.h to know the application version*/

#include "allegro.h"
#include "common.h"
#include "global.h"

#include <stdio.h>
#include <time.h>
#include <string.h>

#define MESSAGE_USAGE "Usage : %s [arg: 640x480f 800x600f 1024x768f 400x300w 640x480w 800x600w 1280x768f 1280x1024f ]"

/*
const int NB_FLEETS=5;
const int FLEETSDATA_nb_ships[]={1,3,5,6,1,0};
const int FLEETSDATA_type_ships[]={0,0,0,0,0,0};
*/
void game(void)
{
  int current_fleet=0;
  int current_level=GLOBAL_beginning_level;//1

  set_auto_quit_menu(0);

  for (int i=0;i<MAX_PLAYERS;i++)
    create_player();

  set_background(current_level);
  set_good_weapon_players(current_level);

  int time_to_create_an_other=0;
 
  while(1)
    {
      /*load the following fleet*/
      //printf("Creating fleet ...\n");

      int might=current_level*6*SETTINGS_difficulty;
      
      int type_of_ship_to_create=random_number(current_level+1);
      if (current_level>7) error_message("ERROR (main.c) : it's possible to create an unknown ship");
      while(might>0)
	{
	  if (random_number(5)==4)
	    type_of_ship_to_create=random_number(current_level+1);
	  create_ship(type_of_ship_to_create);
	  switch (type_of_ship_to_create)
	    {
	    case 0:might--;break;
	    case 1:might-=4;break;
	    case 2:might-=6;break;
	    case 3:might-=8;break;
	    case 4:might-=10;break;
	    case 5:might-=15;break;
	    case 6:might-=20;break;
	    case 7:might-=40;break;
	    default:error_message("ERROR (main.c) : the created ship has an unknown might");break;
	    }
	}   
      permute();
      //printf("Fleet creation finished\n");
      
      while(1)/*game main loop*/
	{
	  //acquire_screen();
	  
	  sprites_clear_background();
	  time_to_create_an_other--;
	  if (time_to_create_an_other<=0)/*create clouds, etc*/
	    {
	      create_other(random_number(2));
	      time_to_create_an_other=20;

	      if (current_level>=7)
    	{
		  create_proj(6,SCREEN_W/2,0,0,1,1);
		  create_proj(7,SCREEN_W/2,0,(random_number(7)-3)/3,0.5,1);
		  create_proj(7,SCREEN_W/2,0,(random_number(7)-3)/3,0.5,1);
		  create_proj(7,SCREEN_W/2,0,(random_number(7)-3)/3,0.5,1);
		}
	    }

	  others_play();
	  players_play();
	  ships_play();
	  projs_play();
	  cause_collision_proj();
	  explosions_play();
	  bonus_play();
	  
	  if (!is_there_a_ship())
	  {
		//printf("Fleet destroyed\n");
	    break;
	    }

	  //if (key[KEY_ALT] || key[KEY_F4]) exit(EXIT_SUCCESS);
	  
	  if (key[KEY_ESC])
	    {
	      open_menubox(100,100,2,1,"Interruption");
	      
	      if (is_auto_quit_menu())
		  	      break;
	      set_background(current_level);
	    }
	  
	  if(are_all_players_dead())
	    {
	      while(!is_auto_quit_menu())
			      open_menubox(100,100,2,1,"Vous avez perdu.");
	      break;
	    }
	    
	  refresh();
	  
	  wait_a_moment(40-SETTINGS_game_speed);
	  	  
	}/*end game main loop*/

      if (is_auto_quit_menu())
	  break;
	    
      current_fleet++;
      if (((float)current_fleet/SETTINGS_level_size) == current_fleet/SETTINGS_level_size && current_fleet!=0)
      	{
	  current_level++;
	  if (current_level>=8)
	    {
	      cinematic_end();
	      break;
	    }
	  set_background(current_level);
	  set_good_weapon_players(current_level);
	}
      //open_menubox(100,100,2,1,"Magasin");      
      
    }

  delete_all_game();
  set_auto_quit_menu(0);
}


int main(int argc, char *argv[])
{
  /*init all and create window*/
  allegro_init();
  set_color_depth(16);
  install_keyboard();
  srand(time(NULL));

  if (argc==2)
    {
      if (strcmp(argv[1],"640x480w")==0)
	{
	  if (set_gfx_mode(GFX_AUTODETECT_WINDOWED, 640,480, 0, 0) != 0)
	    error_message("Unable to set this graphic mode.");
	}
      else if (strcmp(argv[1],"800x600w")==0)
	{
	  if (set_gfx_mode(GFX_AUTODETECT_WINDOWED, 800,600, 0, 0) != 0)
	    error_message("Unable to set this graphic mode.");
	}
      else if (strcmp(argv[1],"400x300w")==0)
	{
	  if (set_gfx_mode(GFX_AUTODETECT_WINDOWED, 400,300, 0, 0) != 0)
	    error_message("Unable to set this graphic mode.");
	}
      else if (strcmp(argv[1],"640x480f")==0)
	{
	  if (set_gfx_mode(GFX_SAFE, 640,480, 0, 0) != 0)
	    error_message("Unable to set this graphic mode.");
	}
      else if (strcmp(argv[1],"800x600f")==0)
	{
	  if (set_gfx_mode(GFX_SAFE, 800,600, 0, 0) != 0)
	    error_message("Unable to set this graphic mode.");
	}
      else if (strcmp(argv[1],"1024x768f")==0)
	{
	  if (set_gfx_mode(GFX_SAFE, 1024,768, 0, 0) != 0)
	    error_message("Unable to set this graphic mode.");
	}
      else if (strcmp(argv[1],"1280x768f")==0)
	{
	  if (set_gfx_mode(GFX_SAFE, 1280,768, 0, 0) != 0)
	    error_message("Unable to set this graphic mode.");
	}
      else if (strcmp(argv[1],"1280x1024f")==0)
	{
	  if (set_gfx_mode(GFX_SAFE, 1280,1024, 0, 0) != 0)
	    error_message("Unable to set this graphic mode.");
	}
      else 
	{
	  sprintf(get_string_for_sprintf(),MESSAGE_USAGE,argv[0]);
	  error_message(get_string_for_sprintf());
	}	  
    }
  else if (argc==1)
    {
      if (set_gfx_mode(GFX_SAFE, 1024,768, 0, 0) != 0)
	error_message("Unable to set any graphic mode.");
    }
  else
    {
      sprintf(get_string_for_sprintf(),MESSAGE_USAGE,argv[0]);
      error_message(get_string_for_sprintf());
    }
  
  init_all();
  //load_SETTINGS();

  while(1)
    {
      /*menu*/
      draw_menu();
      blit(screen, screen2, 0, 0, 0, 0, SCREEN_W, SCREEN_H);
      GLOBAL_beginning_level=1;
      open_menubox(100,100,2,1,"Menu principal");//x=SCREEN_W/2-128-32 y=SCREEN_H/2-32
      
      /*game*/
      if (is_auto_quit_menu())
	  game();
    }
  
  return EXIT_SUCCESS;
}
END_OF_MAIN()
