
#include "allegro.h"
#include "../common.h"
#include "../global.h"
#include "explosion.h"

#define NB_TYPES_EXPLOSIONS 4
#define TIME_BEFORE_DELETE 20

static BITMAP * bitmap_explosion[NB_TYPES_EXPLOSIONS];

void
init_class_explosion(void)
{
    bitmap_explosion[0] = load_bitmap("data/explosion/explo0.bmp",NULL);if (bitmap_explosion[0]==NULL) error_message("ERROR : missing picture explo0.bmp");
    bitmap_explosion[1] = load_bitmap("data/explosion/explo1.bmp",NULL);if (bitmap_explosion[1]==NULL) error_message("ERROR : missing picture explo1.bmp");
    bitmap_explosion[2] = load_bitmap("data/explosion/explo2.bmp",NULL);if (bitmap_explosion[2]==NULL) error_message("ERROR : missing picture explo2.bmp");
    bitmap_explosion[3] = load_bitmap("data/explosion/explo3.bmp",NULL);if (bitmap_explosion[3]==NULL) error_message("ERROR : missing picture explo3.bmp");
}


class_explosion::class_explosion(int x_,int y_,int size_,int damages)
{
  x=x_ - bitmap_explosion[size_]->w /2;
  y=y_ - bitmap_explosion[size_]->h /2;
  size=size_;
  life=1;
  time_before_delete=TIME_BEFORE_DELETE;
  verify_collision_explosion(x,y,bitmap_explosion[size],damages);
}


void
class_explosion::clear_back(void)
{
  blit(screen2,get_good_screen(),x,y,x,y,bitmap_explosion[size]->w,bitmap_explosion[size]->h);
}


void
class_explosion::play(void)
{
  time_before_delete--;
  if(time_before_delete<0)
    life=0;
  draw_sprite(get_good_screen(),bitmap_explosion[size],x,y);
}
