
#include "allegro.h"
#include "../common.h"
#include "menubox.h"

#include <stdio.h>

#include <string.h>

#define NB_COMMANDS 5


static BITMAP * bitmap_hide_char=NULL;


void
init_class_menubox(void)
{
  bitmap_hide_char = load_bitmap("data/hide_char.bmp",NULL);
}


void 
class_menubox::choose_code(int &pos_x_code,char *code)
{
  if (pos_x_code<39)
    {
      int key_nearly_pressed=-1;
      while(key_nearly_pressed==-1)
	for (int i=0;i<KEY_MAX;i++)
	  if (key[i])
	    key_nearly_pressed=i;
      
      if (key_nearly_pressed==KEY_ESC || key_nearly_pressed==KEY_ENTER)
	return;

      if (key[KEY_BACKSPACE])
	{
	  pos_x_code--;
	  code[pos_x_code-1]='\0';
	  for (int i=x+5;i<size_x*160+x-8;i+=8)
	    blit(bitmap_hide_char, screen , 0, 0, i,y-size_y*160/2+40, 8, 10);
	  refresh();	  
	  textout(screen, font,code,x+20+10,y-size_y*80+40,makecol(255,255,255));

	  wait_a_moment(100);
	  /*	  rest(100);*/
	}
      else if (key_nearly_pressed!=-1)
	{
	  key_nearly_pressed=scancode_to_ascii(key_nearly_pressed);
	  code[pos_x_code-1]=(char)key_nearly_pressed;
	  code[pos_x_code]='\0';
	  textout(screen, font,code,x+20+10,y-size_y*80+40,makecol(255,255,255));
	  pos_x_code++;

	  wait_a_moment(200);
	  /*	  rest(200);*/
	}
    }
}

void 
class_menubox::writetext(int relative_x,int relative_y,char text[])
{
  textout(screen, font,text,x+relative_x,y-size_y*80+relative_y,makecol(200,200,200));
}

void
class_menubox::add_items_command_player(int player_index)
{
  add_item(get_key_corresponding_string("Gauche",SETTINGS_player_left[player_index]));
  add_item(get_key_corresponding_string("Droite",SETTINGS_player_right[player_index]));
  add_item(get_key_corresponding_string("Haut",SETTINGS_player_up[player_index]));
  add_item(get_key_corresponding_string("Bas",SETTINGS_player_down[player_index]));
  add_item(get_key_corresponding_string("Selection inventaire",SETTINGS_player_use_inventory_bonus[player_index]));
}

void 
class_menubox::get_command_player(int player_index,int index_item)
{
  textout(screen, font,">>>Appuyez sur une touche ...",x+20,y-size_y*160/2+120,makecol(255,255,255));
  wait_a_moment(300);
  /*  rest(300);*/
  
  int key_nearly_pressed=-1;
  while(key_nearly_pressed==-1)
    for (int i=0;i<KEY_MAX;i++)
      if (key[i])
	key_nearly_pressed=i;
  
  switch(index_item)
    {
    case 1:SETTINGS_player_left[player_index]=key_nearly_pressed;break;
    case 2:SETTINGS_player_right[player_index]=key_nearly_pressed;break;
    case 3:SETTINGS_player_up[player_index]=key_nearly_pressed;break;
    case 4:SETTINGS_player_down[player_index]=key_nearly_pressed;break;
    case 5:SETTINGS_player_use_inventory_bonus[player_index]=key_nearly_pressed;break;
    } 
  
  for (int i=x+5;i<size_x*160+x-8;i+=8)
    blit(bitmap_hide_char, screen , 0, 0, i,y-size_y*160/2+120, 8, 10);
}

class_menubox::class_menubox(int x_,int y_,int size_x_,int size_y_,char title_[])
{
  x=x_;
  y=y_+size_y_/2;
  size_x=size_x_;
  size_y=size_y_;
  title=title_;
  
  create();
  
  print_items();
  
  choose();
}

void 
class_menubox::create(void)
{
  background = bitmap_capture_screen(x,y-size_y*160/2,size_x*160,size_y*160+16);

  /* read in the bitmaps file */
  BITMAP * menubar = load_bitmap("data/menubar.bmp", NULL);
  BITMAP * back_menubox = load_bitmap("data/back_menubox.bmp",NULL);

  if (!menubar || !back_menubox)
    error_message("ERROR : can't read bitmap file.");

  /* blit the images onto the screen */
  for (int k=0;k<=size_y*160/2;k+=size_y*160/2/10)
    {
      for (int i=x;i<size_x*160+x;i+=back_menubox->w)
	for (int j=y-k;j<y+k;j++)
	  blit(back_menubox, screen, 0, 0, i, j, back_menubox->w, back_menubox->h);

      for (int i=x;i<size_x*160+x;i+=160)
	blit(menubar, screen, 0, 0, i, y-k, menubar->w, menubar->h);
      for (int i=x;i<size_x*160+x;i+=160)
	blit(menubar, screen, 0, 0, i, y+k, menubar->w, menubar->h);

      wait_a_moment(8);
      /*      rest(8);*/
    }

  /* destroy the bitmaps */
  destroy_bitmap(menubar);
  destroy_bitmap(back_menubox);

  /*write title*/
  text_mode(-1);
  textout_centre(screen, font,title,(x+x+size_x*160)/2,y-size_y*160/2+3,makecol(255,255,255));
}

void
class_menubox::choose(void)
{
  selection_index_item=1;
  refresh();

  int pos_x_code=0;
  char * code=new char[40];
  
  if (strcmp(title,"Entrer un code")==0)
    {
      pos_x_code=1;
      code[0]='\0';
    }

  while(!key[KEY_ESC] && !is_auto_quit_menu())
    {
      if (key[KEY_UP] && selection_index_item>1)
	{
	  selection_index_item--;
	  refresh();
	}

      if (key[KEY_DOWN] && selection_index_item<nb_items)
	{
	  selection_index_item++;
	  refresh();
	}
      
      if (key[KEY_ENTER])
	execute(selection_index_item);

      if (key[KEY_1_PAD]) execute(1);
      if (key[KEY_2_PAD]) execute(2);
      if (key[KEY_2_PAD]) execute(2);
      if (key[KEY_3_PAD]) execute(3);
      if (key[KEY_4_PAD]) execute(4);
      if (key[KEY_5_PAD]) execute(5);
      if (key[KEY_6_PAD]) execute(6);
      if (key[KEY_7_PAD]) execute(7);
      if (key[KEY_8_PAD]) execute(8);
      if (key[KEY_9_PAD]) execute(9);

      wait_a_moment(8);
      /*      rest_callback(8,(*callback_exit));*/

      if (pos_x_code>0) 
	{
	  choose_code(pos_x_code,code);
	  if (key[KEY_ENTER])
	    if (is_correct_code(code)>0)
	      {
		GLOBAL_beginning_level=is_correct_code(code);
		class_menubox * menubox = new class_menubox(150,150,1,1,"Nombre de joueurs");
		delete menubox;
	      }
	}
    }

  if (strcmp(title,"Fin du jeu")==0)
  set_auto_quit_menu(1);

  /* read in the bitmaps file */
  BITMAP * menubar = load_bitmap("data/menubar.bmp", NULL);
  BITMAP * back_menubox = load_bitmap("data/back_menubox.bmp",NULL);


  /* blit the images onto the screen */
  for (int k=size_y*160/2;k>=0;k-=size_y*160/2/10)
    {
      blit(background, screen, 0, 0, x, y-size_y*160/2,background->w, background->h);

      for (int i=x;i<size_x*160+x;i+=back_menubox->w)
	for (int j=y-k;j<y+k;j++)
	  blit(back_menubox, screen, 0, 0, i, j, back_menubox->w, back_menubox->h);

      for (int i=x;i<size_x*160+x;i+=160)
	blit(menubar, screen, 0, 0, i, y-k, menubar->w, menubar->h);
      for (int i=x;i<size_x*160+x;i+=160)
	blit(menubar, screen, 0, 0, i, y+k, menubar->w, menubar->h);
      
      wait_a_moment(8);
      /*      rest(8);*/
      /*      blit(background, screen, 0, 0, x, y-size_y*160/2,background->w, background->h);*/
    }
  blit(background, screen, 0, 0, x, y-size_y*160/2,background->w, background->h);

  /* destroy the bitmaps */
  destroy_bitmap(menubar);
  destroy_bitmap(back_menubox);

  destroy_bitmap(background);

  delete code;

  wait_a_moment(50);
  /*  rest(50);*/
}

void
class_menubox::print_items(void)
{
  nb_items=0;

  if (strcmp(title,"Menu principal")==0)
    {
      add_item("Partie simple");
      add_item("Options");
      add_item("Aide");
      add_item("Entrer un code");
      add_item("Quitter le jeu");
      return;
    }

  if (strcmp(title,"Nombre de joueurs")==0)
    {
      add_item("1");
      add_item("2");
      add_item("3");
      return;
    }
  if (strcmp(title,"Options")==0)
    {
      sprintf(get_string_for_sprintf(),"Vitesse : %d",SETTINGS_game_speed);
      add_item(get_string_for_sprintf());
      if (SETTINGS_is_double_buffering)
	add_item("Double buffer actif (plus lent)");
      else
	add_item("Double buffer inactif (tend a clignoter)");
      if (SETTINGS_permutation_mode)
	add_item("Permutation des joueurs activee (plus fun pour 3 joueurs)");
      else
	add_item("Permutation des joueurs desactivee (pour 1 ou 2 joueurs)");

      add_item("Commandes joueur 1");
      add_item("Commandes joueur 2");
      add_item("Commandes joueur 3");
      if (SETTINGS_projs_collide_projs)
	add_item("Collision entre projectiles activee");
      else
	add_item("Collision entre projectiles desactivee");
      sprintf(get_string_for_sprintf(),"Taille d'un niveau : %d",SETTINGS_level_size);
      add_item(get_string_for_sprintf());
      sprintf(get_string_for_sprintf(),"Densite d'ennemis : %d",SETTINGS_difficulty);
      add_item(get_string_for_sprintf());
      sprintf(get_string_for_sprintf(),"Degats ennemis x%d",SETTINGS_baddies_damages_coeff);
      add_item(get_string_for_sprintf());
      return;
    }
  /*
  if (strcmp(title,"Magasin")==0)
    {
      add_item("Acheter");
      add_item("Vendre");
      add_item("Quitter");
      return;
    }
  */
  if (strcmp(title,"Interruption")==0)
    {
      add_item("Options");
      add_item("Revenir au menu");
      add_item("Quitter le jeu");
      return;
    }
  if (strcmp(title,"Vous avez perdu.")==0)
    {
      add_item("Revenir au menu");
      add_item("Quitter le jeu");
      return;
    }
  if (strcmp(title,"Commandes joueur 1")==0)
    {
      add_items_command_player(0);
      return;
    }
  if (strcmp(title,"Commandes joueur 2")==0)
    {
      add_items_command_player(1);
      return;
    }
  if (strcmp(title,"Commandes joueur 3")==0)
    {
      add_items_command_player(2);
      add_item("Revenir au menu");
      return;
    }

  if (strcmp(title,"Aide")==0)
    {
      writetext(10,20,"Les commandes sont dans 'Options','Commandes joueur 1,2,3.'");
      writetext(10,40,"ALT+F4 permet de quitter le jeu directement.");
      writetext(10,60,"Le jeu s'etale sur 7 niveaux. Quand vous passez un nouveau niveau :");
      writetext(10,80,"- les armes des joueurs changent");
      writetext(10,95,"- le code du niveau s'affiche en bas a gauche (notez-le)");
      writetext(10,110,"- il y a un nouveau type d'ennemi");
      writetext(10,130,"L'inventaire (en haut a gauche) est commun a tous les joueurs.");
      writetext(10,150,"But du jeu : atteindre le niveau du vaisseau mere et detruire les ennemis.");
      writetext(10,420,"Ce jeu a ete concu par Francois Braud (alias phrounz).");
      writetext(10,440,"Lisez le fichier README.htm pour plus d'informations.");
      writetext(10,460,"Appuyez sur Echap pour quitter cette fenetre.");
      return;
    }

  if (strcmp(title,"Fin du jeu")==0)
    {
      writetext(10,70,"Bravo,");
      writetext(10,90,"vous avez gagne !");
      return;
    }

  if (strcmp(title,"Entrer un code")==0)
    {
      writetext(10,20,"Entrez votre code");
      writetext(20,40,">");
      line(screen,x+20+10,y-size_y*80+40+10,x+20+38*10,y-size_y*80+40+10,makecol(255,255,255));
      return;
    }

  error_message("ERROR : unknown menubox created.");
}

void
class_menubox::add_item(char text[])
{
  nb_items++;
  textout(screen, font,text,x+20,y-size_y*160/2+nb_items*20,makecol(255,255,255));
}

void
class_menubox::execute(int index_item)
{
  
  if (strcmp(title,"Menu principal")==0)
    {
      if (index_item==1)
	{
	  class_menubox * menubox = new class_menubox(150,150,1,1,"Nombre de joueurs");
	  delete menubox;
	}
      else if (index_item==2)
	{
	  class_menubox * menubox = new class_menubox(10,200,3,2,"Options");
	  delete menubox;
	}
      else if (index_item==3)
	{
	  class_menubox * menubox = new class_menubox(10,SCREEN_H/2,4,3,"Aide");
	  delete menubox;
	}
      else if (index_item==4)
	{
	  class_menubox * menubox = new class_menubox(10,SCREEN_H/2,3,1,"Entrer un code");
	  delete menubox;
	}
      else if (index_item==5)
	exit(EXIT_SUCCESS);

    }
  if (strcmp(title,"Nombre de joueurs")==0)
    {
      switch(index_item)
	{
	case 1:GLOBAL_nb_players=1;save_SETTINGS();set_auto_quit_menu(1);break;
	case 2:GLOBAL_nb_players=2;save_SETTINGS();set_auto_quit_menu(1);break;
	case 3:GLOBAL_nb_players=3;save_SETTINGS();set_auto_quit_menu(1);break;
	}
    }
  if (strcmp(title,"Options")==0)
    {
      switch(index_item)
	{
	case 1: 
	  if (SETTINGS_game_speed<40) SETTINGS_game_speed+=5;
	  else SETTINGS_game_speed=0;
	  break;
	case 2:SETTINGS_is_double_buffering=1-SETTINGS_is_double_buffering;break;
	case 3:SETTINGS_permutation_mode=1-SETTINGS_permutation_mode;break;
	case 7:SETTINGS_projs_collide_projs=1-SETTINGS_projs_collide_projs;break;
	case 8:
	  if (SETTINGS_level_size<20) SETTINGS_level_size++;
	  else SETTINGS_level_size=1;
	  break;
	case 9:
	  if (SETTINGS_difficulty<20) SETTINGS_difficulty++;
	  else SETTINGS_difficulty=1;
	  break;
	case 10:
	  if (SETTINGS_baddies_damages_coeff<20) SETTINGS_baddies_damages_coeff++;
	  else SETTINGS_baddies_damages_coeff=1;
	  break;
	}
      if (index_item==4)
	{
	  class_menubox * menubox = new class_menubox(20,200,3,1,"Commandes joueur 1");
	  delete menubox;
	}
      else if (index_item==5)
	{
	  class_menubox * menubox = new class_menubox(20,200,3,1,"Commandes joueur 2");
	  delete menubox;
	}
      else if (index_item==6)
	{
	  class_menubox * menubox = new class_menubox(20,200,3,1,"Commandes joueur 3");
	  delete menubox;
	}
    }
  if (strcmp(title,"Interruption")==0)
    {
      if (index_item==1)
	{
	  class_menubox * menubox = new class_menubox(10,200,3,2,"Options");
	  delete menubox;
	}
      switch(index_item)
	{
	case 2:set_auto_quit_menu(1);break;
	case 3:exit(EXIT_SUCCESS);break;
	}
    }
  if (strcmp(title,"Vous avez perdu.")==0)
    {
      switch(index_item)
	{
	case 1:set_auto_quit_menu(1);break;
	case 2:exit(EXIT_SUCCESS);break;
	}
    }
  if (strcmp(title,"Commandes joueur 1")==0 && index_item<=NB_COMMANDS)
      get_command_player(0,index_item);
  if (strcmp(title,"Commandes joueur 2")==0 && index_item<=NB_COMMANDS)
      get_command_player(1,index_item);
  if (strcmp(title,"Commandes joueur 3")==0 && index_item<=NB_COMMANDS)
      get_command_player(2,index_item);

  if (strcmp(title,"Fin du jeu")==0)
    set_auto_quit_menu(1);
  
  refresh();
}

void
class_menubox::refresh(void)
{
  for (int j=1;j<=nb_items;j++)
    for (int i=x+5;i<size_x*160+x-8;i+=8)
      blit(bitmap_hide_char, screen , 0, 0, i,y-size_y*160/2+j*20, 8, 10);
  print_items();
  if (nb_items>0)
    textout(screen, font,">",x+5,y-size_y*160/2+selection_index_item*20,makecol(255,255,255));

  wait_a_moment(100);
  /*  rest_callback(100,(*callback_exit));*/
}
