
#include "allegro.h"
#include "../common.h"
#include "../global.h"
#include "proj.h"

#include <math.h>

#define NB_TYPES_PROJ 11

static BITMAP * bitmap_proj[NB_TYPES_PROJ];

static const int PROJ_SPEED[]={10,12,25,10,20,10,20,8,8,10,10};
static const int PROJ_DAMAGES[]={5,10,40,25,15,25,30,6,6,3,1000};
static const int PROJ_EXPLOSION_SIZE[]={0,0,1,1,1,0,1,0,0,0,3};
static const int PROJ_DIRECTION[]={0,0,0,0,0,0,0,0,0,0,0};
static const int PROJ_AUTOLOCK[]={0,0,0,0,0,2,0,0,1,2,0};
static const int PROJ_TIME_BEFORE_DESTROY[]={-1,-1,-1,-1,-1,-1,-1,-1,70,50,-1};

void
init_class_proj(void)
{
  bitmap_proj[0] = load_bitmap("data/proj/proj0.bmp",NULL);
  bitmap_proj[1] = load_bitmap("data/proj/proj1.bmp",NULL);
  bitmap_proj[2] = load_bitmap("data/proj/proj2.bmp",NULL);
  bitmap_proj[3] = load_bitmap("data/proj/proj3.bmp",NULL);
  bitmap_proj[4] = load_bitmap("data/proj/proj4.bmp",NULL);
  bitmap_proj[5] = load_bitmap("data/proj/proj5.bmp",NULL);
  bitmap_proj[6] = load_bitmap("data/proj/proj6.bmp",NULL);
  bitmap_proj[7] = load_bitmap("data/proj/proj_s0.bmp",NULL);
  bitmap_proj[8] = load_bitmap("data/proj/proj_s0.bmp",NULL);
  bitmap_proj[9] = load_bitmap("data/proj/proj_s1.bmp",NULL);
  bitmap_proj[10] = load_bitmap("data/proj/proj_b0.bmp",NULL);
}


class_proj::class_proj(int type_of_proj_,int x_,int y_,float mvt_x_,float mvt_y_,int is_baddy_)
{
  type_of_proj=type_of_proj_;
  
  x=x_;
  y=y_;
  initial_x=x_;
  initial_y=y_;
  life=1;
  speed=PROJ_SPEED[type_of_proj];
  is_baddy=is_baddy_;
  time_before_destroy=PROJ_TIME_BEFORE_DESTROY[type_of_proj];
  
  /*direction of shoot*/
  if (PROJ_AUTOLOCK[type_of_proj]>0)
    {
      autolock_cible=get_a_cible(is_baddy);
      angle_to_cible=get_the_angle_to_cible(x,y,autolock_cible,is_baddy);
      mvt_x=cos(angle_to_cible);
      mvt_y=sin(angle_to_cible);
    }
  else
    switch(PROJ_DIRECTION[type_of_proj])
      {
      case 0:mvt_x=mvt_x_;mvt_y=mvt_y_;break;/*same direction*/
      case 1:mvt_x=-mvt_y_;mvt_y=mvt_x_;break;/*right*/
      case 2:mvt_x=-mvt_x_;mvt_y=-mvt_y_;break;/*opposing direction*/
      case 3:mvt_x=mvt_y_;mvt_y=-mvt_x_;break;/*left*/
      }
}

void
class_proj::clear_back(void)
{
  blit(screen2,get_good_screen(),
       x-bitmap_proj[type_of_proj]->w,y-bitmap_proj[type_of_proj]->h,
       x-bitmap_proj[type_of_proj]->w,y-bitmap_proj[type_of_proj]->h,
       bitmap_proj[type_of_proj]->w*3,bitmap_proj[type_of_proj]->h*3);
}

void
class_proj::play(void)
{  
  
  x=x+(int)(mvt_x*speed);
  y=y+(int)(mvt_y*speed);

  if (time_before_destroy>0)
    {
      time_before_destroy--;
      if (time_before_destroy==0) life=0;
    }
  
  if (x+bitmap_proj[type_of_proj]->w<-10 && initial_x+bitmap_proj[type_of_proj]->w>0) life=0;
  if (y+bitmap_proj[type_of_proj]->h<-10 && initial_y+bitmap_proj[type_of_proj]->h>0) life=0;
  if (x>SCREEN_W+10 && initial_x<SCREEN_W) life=0;
  if (y>SCREEN_H+10 && initial_y<SCREEN_H) life=0;

  if (x+bitmap_proj[type_of_proj]->w<-400) life=0;
  if (y+bitmap_proj[type_of_proj]->h<-400) life=0;
  if (x>SCREEN_W+400) life=0;
  if (y>SCREEN_H+400) life=0;


  if (PROJ_AUTOLOCK[type_of_proj])
    {
      if (PROJ_AUTOLOCK[type_of_proj]>1)
	{
	  angle_to_cible=get_the_angle_to_cible(x,y,autolock_cible,is_baddy);
	  mvt_x=cos(angle_to_cible);
	  mvt_y=sin(angle_to_cible);
	}
      rotate_sprite(get_good_screen(),bitmap_proj[type_of_proj],x,y,ftofix(angle_to_cible*256/(2*3.1415)));
    }
  else if (mvt_y==1)
      draw_sprite_v_flip(get_good_screen(),bitmap_proj[type_of_proj],x-bitmap_proj[type_of_proj]->w/2,y-bitmap_proj[type_of_proj]->h/2);
  else
      draw_sprite(get_good_screen(),bitmap_proj[type_of_proj],x-bitmap_proj[type_of_proj]->w/2,y-bitmap_proj[type_of_proj]->h/2);
}

BITMAP * 
class_proj::get_bitmap_of_proj(void)
{
  return bitmap_proj[type_of_proj];
}

int
class_proj::is_colliding(int x_bitmap,int y_bitmap,BITMAP * the_bitmap)
{
  if (x_bitmap < x+bitmap_proj[type_of_proj]->w   &&   x_bitmap+the_bitmap->w > x)
    if (y_bitmap < y+bitmap_proj[type_of_proj]->h   &&   y_bitmap+the_bitmap->h > y)
      return 1;

  return 0;
}


void 
class_proj::explode(void)
{
  create_explosion(x+bitmap_proj[type_of_proj]->w/2, y+bitmap_proj[type_of_proj]->h/2 ,PROJ_EXPLOSION_SIZE[type_of_proj],PROJ_DAMAGES[type_of_proj]*SETTINGS_baddies_damages_coeff);
}
