
#include "allegro.h"
#include "common.h"
#include <stdio.h>
#include <string.h>
#include <time.h>
#include <unistd.h>

#define CODE_LEVEL_2 "pas si dur"
#define CODE_LEVEL_3 "pas si facile"
#define CODE_LEVEL_4 "trop hyper dur"
#define CODE_LEVEL_5 "allons-y"
#define CODE_LEVEL_6 "--impossible--"
#define CODE_LEVEL_7 "folie furieuse"

int SETTINGS_game_speed;
int SETTINGS_is_double_buffering;
int SETTINGS_nb_players;
int SETTINGS_permutation_mode;
int SETTINGS_level_size;
int SETTINGS_difficulty;
int SETTINGS_baddies_damages_coeff;
int SETTINGS_player_left[3];
int SETTINGS_player_right[3];
int SETTINGS_player_up[3];
int SETTINGS_player_down[3];
int SETTINGS_player_use_inventory_bonus[3];
int SETTINGS_projs_collide_projs;

int GLOBAL_nb_players=1;
int GLOBAL_beginning_level=1;

BITMAP * screen2;
static BITMAP * screen3;

static char string_for_sprintf[300];
static int is_quitting_menu=0;

int MAX_INVENTORY_OBJECTS=5;


static char *
string_duplication(const char s[]) 
{
  char *value;
  value=new char[strlen(s)+1];
  for (unsigned int i=0;i<=strlen(s);i++)
    value[i]=s[i];

  return (value);
}


/*
static char *
string_concatenation(const char s1[], const char s2[]) 
{
  int i;
  int sizeofstring=strlen(s1)+strlen(s2)+1;
  char *string;
  string=(char *)malloc(sizeofstring);

  for (i=0;i<sizeofstring;i++)
    string[i]=' ';
  for (i=0;s1[i]!='\0';i++)
    string[i]=s1[i];
  for (i=0;s2[i]!='\0';i++)
    string[i+strlen(s1)]=s2[i];
  string[i+strlen(s1)]='\0';
  return(string);
}
*/

static void 
init_SETTINGS(void)
{
  SETTINGS_game_speed=20;
  SETTINGS_is_double_buffering=1;
  SETTINGS_nb_players=0;
  SETTINGS_permutation_mode=0;
  SETTINGS_projs_collide_projs=0;
  SETTINGS_level_size=9;
  SETTINGS_difficulty=3;
  SETTINGS_baddies_damages_coeff=1;
  
  for (int i=0;i<3;i++)
    {
      SETTINGS_player_left[0]=KEY_LEFT;
      SETTINGS_player_right[0]=KEY_RIGHT;
      SETTINGS_player_up[0]=KEY_UP;
      SETTINGS_player_down[0]=KEY_DOWN;
      SETTINGS_player_use_inventory_bonus[0]=KEY_DEL;

      SETTINGS_player_left[1]=KEY_Q;
      SETTINGS_player_right[1]=KEY_D;
      SETTINGS_player_up[1]=KEY_Z;
      SETTINGS_player_down[1]=KEY_S;
      SETTINGS_player_use_inventory_bonus[1]=KEY_A;

      SETTINGS_player_left[2]=KEY_4_PAD;
      SETTINGS_player_right[2]=KEY_6_PAD;
      SETTINGS_player_up[2]=KEY_8_PAD;
      SETTINGS_player_down[2]=KEY_5_PAD;
      SETTINGS_player_use_inventory_bonus[2]=KEY_0_PAD;
    }
}


void 
init_all_commons(void)
{
  init_SETTINGS();
  screen2 = create_bitmap(SCREEN_W,SCREEN_H);
  screen3 = create_bitmap(SCREEN_W,SCREEN_H);
}


char * 
get_string_for_sprintf(void)
{
  return string_for_sprintf;
}

void
error_message(const char * text)
{
  set_gfx_mode(GFX_TEXT, 0, 0, 0, 0);
  allegro_message("%s\n",text);
  exit(EXIT_FAILURE);
}

BITMAP *
bitmap_capture_screen(int x, int y, int size_x,int size_y)
{
  BITMAP * image = create_bitmap(size_x,size_y);
  blit(screen, image, x, y, 0, 0, size_x, size_y);
  return image;
}

void
stop_for_debug(void)
{
  while(1)
  {
    if (key[KEY_ALT] && key[KEY_F4])
      break;
  }

  exit(EXIT_SUCCESS);
}

void callback_exit(void)
{
  if (key[KEY_F4] && key[KEY_ALT])
    exit(EXIT_SUCCESS);
}

int
random_number(int max)/*from 0 to max-1*/
{
  float multi_rand=(float) rand() * max;
  float r=multi_rand / (float) RAND_MAX;

  return ((int) r);
}



/*quit menu*/
void set_auto_quit_menu(int boolean_value)
{
  is_quitting_menu=boolean_value;
}
int is_auto_quit_menu(void)
{
  return is_quitting_menu;
}

/*
void load_SETTINGS(void)
{
  char * home_path=getenv("HOME");
  char * file_path=string_concatenation(home_path,"/.bluesky++");
  FILE * settings_file=fopen(file_path,"r");
  if (settings_file==NULL)
    {
      system("echo 10 0 0 > ${HOME}/.bluesky++");
    }
  else
    {
      system("set `cat ${HOME}/.bluesky++`; FR=$1");
      char * tr=getenv("FR");
      if (tr==NULL)
	exit(0);
      error_message(tr);
      SETTINGS_game_speed=atoi(tr);
           SETTINGS_is_double_buffering=atoi(getenv("2"));
    }
}
*/

void save_SETTINGS(void)
{

}


BITMAP *get_good_screen(void)
{
  if (SETTINGS_is_double_buffering)
    return screen3;
  else
    return screen;
}


void set_background(int index)
{
  BITMAP * bitmap_game_background;
  char * code;

  switch(index)
    {
    case 1:bitmap_game_background=load_bitmap("data/background1.bmp",NULL);code=string_duplication(" ");break;
    case 2:bitmap_game_background=load_bitmap("data/background2.bmp",NULL);code=string_duplication(CODE_LEVEL_2);break;
    case 3:bitmap_game_background=load_bitmap("data/background3.bmp",NULL);code=string_duplication(CODE_LEVEL_3);break;
    case 4:bitmap_game_background=load_bitmap("data/background4.bmp",NULL);code=string_duplication(CODE_LEVEL_4);break;
    case 5:bitmap_game_background=load_bitmap("data/background5.bmp",NULL);code=string_duplication(CODE_LEVEL_5);break;
    case 6:bitmap_game_background=load_bitmap("data/background6.bmp",NULL);code=string_duplication(CODE_LEVEL_6);break;
    case 7:bitmap_game_background=load_bitmap("data/background7.bmp",NULL);code=string_duplication(CODE_LEVEL_7);break;
    default:error_message("ERROR : background level unknown");break;
    }


  /* blit the image onto the screens */
  for (int i=0;i<SCREEN_W;i+=bitmap_game_background->w)
    for (int j=0;j<SCREEN_H;j+=bitmap_game_background->h)
      {
	blit(bitmap_game_background, screen, 0, 0, i, j, bitmap_game_background->w, bitmap_game_background->h);
	blit(bitmap_game_background, screen2, 0, 0, i, j, bitmap_game_background->w, bitmap_game_background->h);
	blit(bitmap_game_background, screen3, 0, 0, i, j, bitmap_game_background->w, bitmap_game_background->h);
      }

  textout(screen,font,code,100,SCREEN_H-20,makecol(255,255,255));
  textout(screen2,font,code,100,SCREEN_H-20,makecol(255,255,255));
  textout(screen3,font,code,100,SCREEN_H-20,makecol(255,255,255));
  textout_right(screen,font,"Code : ",100,SCREEN_H-20,makecol(255,255,255));
  textout_right(screen2,font,"Code : ",100,SCREEN_H-20,makecol(255,255,255));
  textout_right(screen3,font,"Code : ",100,SCREEN_H-20,makecol(255,255,255));
  delete code;

  /*last level big boss*/
  if (index==7)
    {
      BITMAP * bitmap_final_boss=load_bitmap("data/final_boss.bmp",NULL);
      for (int i=0;i<SCREEN_W;i+=bitmap_final_boss->w)
	{  
	  draw_sprite(screen, bitmap_final_boss, i, 0);
	  draw_sprite(screen2,bitmap_final_boss, i, 0);
	  draw_sprite(screen3,bitmap_final_boss, i, 0);
	}
      delete bitmap_final_boss;
    }
  
  delete bitmap_game_background;
}


void refresh(void)
{
  if (SETTINGS_is_double_buffering)
    blit(get_good_screen(),screen,0,0,0,0,SCREEN_W,SCREEN_H);
  release_screen();
}

void print_int_at(int value,int x,int y)
{
  sprintf(get_string_for_sprintf(),"%d",value);
  textout(screen,font,get_string_for_sprintf(),x,y,0);
}

char * get_key_corresponding_string(char first_string[],int key_index)
{
  switch(key_index)
    {
    case KEY_ENTER:sprintf(get_string_for_sprintf(),"%s : touche entree",first_string);break;
    case KEY_SPACE:sprintf(get_string_for_sprintf(),"%s : touche espace",first_string);break;
    case KEY_ALT:sprintf(get_string_for_sprintf(),"%s : touche alt",first_string);break;
    case KEY_ALTGR:sprintf(get_string_for_sprintf(),"%s : touche alt gr",first_string);break;
    case KEY_F1:case KEY_F2:case KEY_F3:case KEY_F4:case KEY_F5:case KEY_F6:
    case KEY_F7:case KEY_F8:case KEY_F9:case KEY_F10:case KEY_F11:case KEY_F12:
      sprintf(get_string_for_sprintf(),"%s : une des touches F",first_string);break;

    case KEY_LEFT:sprintf(get_string_for_sprintf(),"%s : touche gauche",first_string);break;
    case KEY_RIGHT:sprintf(get_string_for_sprintf(),"%s : touche droite",first_string);break;
    case KEY_UP:sprintf(get_string_for_sprintf(),"%s : touche haut",first_string);break;
    case KEY_DOWN:sprintf(get_string_for_sprintf(),"%s : touche bas",first_string);break;

    case KEY_TAB:sprintf(get_string_for_sprintf(),"%s : touche tab",first_string);break;
    case KEY_LSHIFT:sprintf(get_string_for_sprintf(),"%s : touche shift gauche",first_string);break;
    case KEY_RSHIFT:sprintf(get_string_for_sprintf(),"%s : touche shift droite",first_string);break;
    case KEY_LCONTROL:sprintf(get_string_for_sprintf(),"%s : touche control g.",first_string);break;
    case KEY_RCONTROL:sprintf(get_string_for_sprintf(),"%s : touche control d.",first_string);break;

    case KEY_DEL:sprintf(get_string_for_sprintf(),"%s : touche suppr",first_string);break;
    case KEY_END:sprintf(get_string_for_sprintf(),"%s : touche fin",first_string);break;
    case KEY_PGUP:sprintf(get_string_for_sprintf(),"%s : touche page prec.",first_string);break;
    case KEY_PGDN:sprintf(get_string_for_sprintf(),"%s : touche page suiv.",first_string);break;
    case KEY_INSERT:sprintf(get_string_for_sprintf(),"%s : touche inser",first_string);break;
    case KEY_HOME:sprintf(get_string_for_sprintf(),"%s : touche debut",first_string);break;

    default:sprintf(get_string_for_sprintf(),"%s : %c",first_string,(scancode_to_ascii(key_index)));break;
    }

  return get_string_for_sprintf();
}


void draw_menu(void)
{
  /* read in the bitmap file */
  BITMAP * menu_cloud = load_bitmap("data/church_cloud.bmp",NULL);

  if (!menu_cloud)
    error_message("ERROR : can't read bitmap data/sky_back.bmp or data/cloud.bmp file.");
  
  //  set_background(1);
  rectfill(get_good_screen(),0,0,SCREEN_W,SCREEN_H,makecol(0,0,0));
  //  blit(menu_cloud, get_good_screen(), 0, 0, SCREEN_W/2-menu_cloud->w/2, SCREEN_H/2-menu_cloud->h/2, menu_cloud->w, menu_cloud->h);
  stretch_blit(menu_cloud,get_good_screen(),0,0,menu_cloud->w,menu_cloud->h,0,0,SCREEN_W,SCREEN_H);

  /*write text*/
  text_mode(-1);
  textout(get_good_screen(), font,VERSION_OF_APPLICATION,10,SCREEN_H-20,makecol(255,255,255));

  /* destroy the bitmaps */
  destroy_bitmap(menu_cloud);

  refresh();
}


int is_correct_code(char *code_given)
{
  if (!strcmp(code_given,CODE_LEVEL_2))
    return 2;
  else if (!strcmp(code_given,CODE_LEVEL_3))
    return 3;
  else if (!strcmp(code_given,CODE_LEVEL_4))
    return 4;
  else if (!strcmp(code_given,CODE_LEVEL_5))
    return 5;
  else if (!strcmp(code_given,CODE_LEVEL_6))
    return 6;
  else if (!strcmp(code_given,CODE_LEVEL_7))
    return 7;
  else
    return 0;
}

extern void wait_a_moment(int time_in_miliseconds)
{
	  #if !defined(WIN32) //linux
	  usleep(time_in_miliseconds*1000);
	  #endif
	  
	  #if defined(WIN32) //windows
	  rest_callback(time_in_miliseconds,(*callback_exit));
	  #endif
}
