#ifndef COMMON_H
#define COMMON_H

#define VERSION_OF_APPLICATION "Bluesky++  version 1.2.0, made by phrounz"

#define MAX_PLAYERS 3

/*main menu*/
extern void draw_menu(void);

/*initialisation*/
extern void init_all_commons(void);

/*settings*/
extern int SETTINGS_game_speed;
extern int SETTINGS_is_double_buffering;
extern int SETTINGS_permutation_mode;
extern int SETTINGS_projs_collide_projs;
extern int SETTINGS_level_size;
extern int SETTINGS_difficulty;
extern int SETTINGS_baddies_damages_coeff;
extern int GLOBAL_nb_players;
extern int GLOBAL_beginning_level;
extern int SETTINGS_player_left[];
extern int SETTINGS_player_right[];
extern int SETTINGS_player_up[];
extern int SETTINGS_player_down[];
extern int SETTINGS_player_use_inventory_bonus[];
extern int MAX_INVENTORY_OBJECTS;
extern void load_SETTINGS(void);
extern void save_SETTINGS(void);

/*divers*/
extern char * get_string_for_sprintf(void);
extern void error_message(const char * text);
extern BITMAP * bitmap_capture_screen(int x, int y, int size_x,int size_y);
extern void stop_for_debug(void);
extern int random_number(int max);/*from 0 to max-1*/
extern void callback_exit(void);

extern void set_background(int index);
extern int is_correct_code(char *code_given);

extern void print_int_at(int value,int x,int y);
extern char * get_key_corresponding_string(char beginning[],int key_index);

extern void wait_a_moment(int time_in_miliseconds);

/*quit menu*/
extern void set_auto_quit_menu(int boolean_value);
extern int is_auto_quit_menu(void);

/*screen2*/
extern BITMAP * screen2;

/*double buffering*/
extern BITMAP * get_good_screen(void);
extern void refresh(void);

#endif /*COMMON_H*/
