
#include "allegro.h"
#include "inventory.h"
#include "common.h"
#include "classes/player.h"

struct s_inventory_table
{
  int type_of_bonus;
  BITMAP * image_of_bonus;
};

struct s_inventory_table inventory_table[5];

void 
inventory_init(void)
{
  for (int i=0;i<MAX_INVENTORY_OBJECTS;i++)
    {
      inventory_table[i].type_of_bonus=-1;
      inventory_table[i].image_of_bonus=NULL;
    }
}


int
inventory_add(int type_of_bonus_,BITMAP * image_of_bonus_)
{
  for (int i=0;i<MAX_INVENTORY_OBJECTS;i++)
    if (inventory_table[i].type_of_bonus==-1 && inventory_table[i].image_of_bonus==NULL)
      {
	inventory_table[i].type_of_bonus=type_of_bonus_;
	inventory_table[i].image_of_bonus=image_of_bonus_;
	return 1;
      }

  return 0;
}

void 
inventory_clear(void)
{
  blit(screen2,get_good_screen(),32,32,32,32,MAX_INVENTORY_OBJECTS*32,32);
}

void
inventory_show(void)
{
  rect(get_good_screen(),32,32,32+MAX_INVENTORY_OBJECTS*32-1,63,makecol(0,0,0));

  for (int i=0;i<MAX_INVENTORY_OBJECTS;i++)
    switch(inventory_table[i].type_of_bonus)
      {  
      case -1:break;
      default:draw_sprite(get_good_screen(),inventory_table[i].image_of_bonus,32+i*32,32);;break;
      }    
}

int 
inventory_use(void)
{
  int type_bonus=inventory_table[0].type_of_bonus;

  for (int i=0;i<MAX_INVENTORY_OBJECTS;i++)
    {
      inventory_table[i].type_of_bonus=inventory_table[i+1].type_of_bonus;
      inventory_table[i].image_of_bonus=inventory_table[i+1].image_of_bonus;
    }

  inventory_table[MAX_INVENTORY_OBJECTS-1].type_of_bonus=-1;
  inventory_table[MAX_INVENTORY_OBJECTS-1].image_of_bonus=NULL;
  
  return type_bonus;
}
